blob: f3798e4c5ad7782585ff5af17ca81702018be5b4 [file] [log] [blame]
garciadeblas93c61312016-09-28 15:12:48 +02001#!/bin/bash
garciadeblas38d91ee2019-11-07 16:31:23 +01002#
3# Licensed under the Apache License, Version 2.0 (the "License");
4# you may not use this file except in compliance with the License.
5# You may obtain a copy of the License at
6#
7# http://www.apache.org/licenses/LICENSE-2.0
8#
9# Unless required by applicable law or agreed to in writing, software
10# distributed under the License is distributed on an "AS IS" BASIS,
11# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
12# See the License for the specific language governing permissions and
13# limitations under the License.
14#
garciadeblasd8bc5c32018-05-09 17:37:56 +020015REPOSITORY_BASE=https://osm-download.etsi.org/repository/osm/debian
garciadeblasfa81f282020-12-15 00:32:13 +000016RELEASE=ReleaseNINE
garciadeblas7bcadc52020-02-02 22:40:15 +010017REPOSITORY=stable
garciadeblasfa81f282020-12-15 00:32:13 +000018DOCKER_TAG=9
garciadeblas93c61312016-09-28 15:12:48 +020019
garciadeblas38d91ee2019-11-07 16:31:23 +010020function usage(){
21 echo -e "usage: $0 [OPTIONS]"
22 echo -e "Install OSM from binaries or source code (by default, from binaries)"
23 echo -e " OPTIONS"
garciadeblas7f1e1042020-11-30 14:07:03 +000024 echo -e " -h / --help: print this help"
25 echo -e " -y: do not prompt for confirmation, assumes yes"
garciadeblas38d91ee2019-11-07 16:31:23 +010026 echo -e " -r <repo>: use specified repository name for osm packages"
27 echo -e " -R <release>: use specified release for osm binaries (deb packages, lxd images, ...)"
28 echo -e " -u <repo base>: use specified repository url for osm packages"
29 echo -e " -k <repo key>: use specified repository public key url"
30 echo -e " -b <refspec>: install OSM from source code using a specific branch (master, v2.0, ...) or tag"
31 echo -e " -b master (main dev branch)"
32 echo -e " -b v2.0 (v2.0 branch)"
33 echo -e " -b tags/v1.1.0 (a specific tag)"
34 echo -e " ..."
garciadeblascb129372020-11-14 23:06:42 +000035 echo -e " -c <orchestrator> deploy osm services using container <orchestrator>. Valid values are <k8s> or <swarm>. If -c is not used then osm will be deployed using default orchestrator. When used with --uninstall, osm services deployed by the orchestrator will be uninstalled"
vijaynag4b57d462020-06-08 14:23:10 +000036 echo -e " -n <ui> install OSM with Next Gen UI. Valid values are <lwui> or <ngui>. If -n is not specified osm will be installed with light-ui. When used with uninstall, osm along with the UI specified will be uninstalled"
garciadeblascb129372020-11-14 23:06:42 +000037 echo -e " -s <stack name> or <namespace> user defined stack name when installed using swarm or namespace when installed using k8s, default is osm"
garciadeblas38d91ee2019-11-07 16:31:23 +010038 echo -e " -H <VCA host> use specific juju host controller IP"
39 echo -e " -S <VCA secret> use VCA/juju secret key"
40 echo -e " -P <VCA pubkey> use VCA/juju public key file"
41 echo -e " -C <VCA cacert> use VCA/juju CA certificate file"
42 echo -e " -A <VCA apiproxy> use VCA/juju API proxy"
43 echo -e " --vimemu: additionally deploy the VIM emulator as a docker container"
44 echo -e " --elk_stack: additionally deploy an ELK docker stack for event logging"
magnussonl1bbe9452020-02-25 13:43:17 +010045 echo -e " --pla: install the PLA module for placement support"
garciadeblascb129372020-11-14 23:06:42 +000046 echo -e " -m <MODULE>: install OSM but only rebuild the specified docker images (LW-UI, NBI, LCM, RO, MON, POL, KAFKA, MONGO, PROMETHEUS, PROMETHEUS-CADVISOR, KEYSTONE-DB, PLA, NONE)"
47 echo -e " -o <ADDON>: ONLY (un)installs one of the addons (vimemu, elk_stack, k8s_monitor)"
48 echo -e " -O <openrc file/cloud name>: Install OSM to an OpenStack infrastructure. <openrc file/cloud name> is required. If a <cloud name> is used, the clouds.yaml file should be under ~/.config/openstack/ or /etc/openstack/"
49 echo -e " -N <openstack public network name/ID>: Public network name required to setup OSM to OpenStack"
garciadeblas38d91ee2019-11-07 16:31:23 +010050 echo -e " -D <devops path> use local devops installation path"
51 echo -e " -w <work dir> Location to store runtime installation"
52 echo -e " -t <docker tag> specify osm docker tag (default is latest)"
David Garcia79f4f532020-04-07 12:59:34 +020053 echo -e " -l: LXD cloud yaml file"
54 echo -e " -L: LXD credentials yaml file"
David Garcia404ae122020-04-28 11:47:55 +020055 echo -e " -K: Specifies the name of the controller to use - The controller must be already bootstrapped"
garciadeblas7f1e1042020-11-30 14:07:03 +000056 echo -e " -d <docker registry URL> use docker registry URL instead of dockerhub"
57 echo -e " -p <docker proxy URL> set docker proxy URL as part of docker CE configuration"
garciadeblas9a510862021-04-21 14:15:56 +020058 echo -e " -T <docker tag> specify docker tag for the modules specified with option -m"
59 echo -e " --nocachelxdimages: do not cache local lxd images, do not create cronjob for that cache (will save installation time, might affect instantiation time)"
David Garcia79f4f532020-04-07 12:59:34 +020060 echo -e " --nolxd: do not install and configure LXD, allowing unattended installations (assumes LXD is already installed and confifured)"
garciadeblas38d91ee2019-11-07 16:31:23 +010061 echo -e " --nodocker: do not install docker, do not initialize a swarm (assumes docker is already installed and a swarm has been initialized)"
62 echo -e " --nojuju: do not juju, assumes already installed"
63 echo -e " --nodockerbuild:do not build docker images (use existing locally cached images)"
64 echo -e " --nohostports: do not expose docker ports to host (useful for creating multiple instances of osm on the same host)"
65 echo -e " --nohostclient: do not install the osmclient"
66 echo -e " --uninstall: uninstall OSM: remove the containers and delete NAT rules"
67 echo -e " --source: install OSM from source code using the latest stable tag"
68 echo -e " --develop: (deprecated, use '-b master') install OSM from source code using the master branch"
garciadeblas38d91ee2019-11-07 16:31:23 +010069 echo -e " --pullimages: pull/run osm images from docker.io/opensourcemano"
garciadeblascb129372020-11-14 23:06:42 +000070 echo -e " --k8s_monitor: install the OSM kubernetes monitoring with prometheus and grafana"
71 echo -e " --volume: create a VM volume when installing to OpenStack"
garciadeblas38d91ee2019-11-07 16:31:23 +010072 echo -e " --showopts: print chosen options and exit (only for debugging)"
Dominik Fleischmann7a97a4c2020-06-04 10:52:05 +020073 echo -e " --charmed: Deploy and operate OSM with Charms on k8s"
74 echo -e " [--bundle <bundle path>]: Specify with which bundle to deploy OSM with charms (--charmed option)"
75 echo -e " [--k8s <kubeconfig path>]: Specify with which kubernetes to deploy OSM with charms (--charmed option)"
garciadeblascb129372020-11-14 23:06:42 +000076 echo -e " [--vca <name>]: Specifies the name of the controller to use - The controller must be already bootstrapped (--charmed option)"
77 echo -e " [--lxd <yaml path>]: Takes a YAML file as a parameter with the LXD Cloud information (--charmed option)"
Dominik Fleischmann7a97a4c2020-06-04 10:52:05 +020078 echo -e " [--lxd-cred <yaml path>]: Takes a YAML file as a parameter with the LXD Credentials information (--charmed option)"
79 echo -e " [--microstack]: Installs microstack as a vim. (--charmed option)"
Dominik Fleischmannc57296f2020-06-09 11:45:08 +020080 echo -e " [--ha]: Installs High Availability bundle. (--charmed option)"
garciadeblascb129372020-11-14 23:06:42 +000081 echo -e " [--tag]: Docker image tag. (--charmed option)"
82 echo -e " [--registry]: Docker registry with optional credentials as user:pass@hostname:port (--charmed option)"
Dominik Fleischmann7a97a4c2020-06-04 10:52:05 +020083
garciadeblas38d91ee2019-11-07 16:31:23 +010084}
85
garciadeblasd8bc5c32018-05-09 17:37:56 +020086add_repo() {
87 REPO_CHECK="^$1"
88 grep "${REPO_CHECK/\[arch=amd64\]/\\[arch=amd64\\]}" /etc/apt/sources.list > /dev/null 2>&1
89 if [ $? -ne 0 ]
90 then
garciadeblasbd925e42018-06-14 14:32:12 +020091 need_packages_lw="software-properties-common apt-transport-https"
92 echo -e "Checking required packages: $need_packages_lw"
93 dpkg -l $need_packages_lw &>/dev/null \
94 || ! echo -e "One or several required packages are not installed. Updating apt cache requires root privileges." \
95 || sudo apt-get -q update \
Mike Marchetti34124182018-10-16 08:22:30 -040096 || ! echo "failed to run apt-get update" \
garciadeblasbd925e42018-06-14 14:32:12 +020097 || exit 1
98 dpkg -l $need_packages_lw &>/dev/null \
99 || ! echo -e "Installing $need_packages_lw requires root privileges." \
100 || sudo apt-get install -y $need_packages_lw \
Mike Marchetti34124182018-10-16 08:22:30 -0400101 || ! echo "failed to install $need_packages_lw" \
garciadeblasbd925e42018-06-14 14:32:12 +0200102 || exit 1
garciadeblasd8bc5c32018-05-09 17:37:56 +0200103 wget -qO - $REPOSITORY_BASE/$RELEASE/OSM%20ETSI%20Release%20Key.gpg | sudo apt-key add -
104 sudo DEBIAN_FRONTEND=noninteractive add-apt-repository -y "$1" && sudo DEBIAN_FRONTEND=noninteractive apt-get update
garciadeblas429b9f82018-03-20 02:09:44 +0100105 return 0
garciadeblasd8bc5c32018-05-09 17:37:56 +0200106 fi
107
108 return 1
garciadeblas55490d42016-10-29 14:22:03 +0200109}
110
garciadeblas25e87d22020-01-31 14:27:29 +0100111clean_old_repo() {
madaviae0784f2020-01-22 16:29:19 +0530112dpkg -s 'osm-devops' &> /dev/null
madaviae0784f2020-01-22 16:29:19 +0530113if [ $? -eq 0 ]; then
madaviae0784f2020-01-22 16:29:19 +0530114 # Clean the previous repos that might exist
115 sudo sed -i "/osm-download.etsi.org/d" /etc/apt/sources.list
116fi
117}
118
Antonio Marsico75a38c72020-12-21 17:29:42 +0100119while getopts ":b:r:c:n:k:u:R:l:L:K:p:D:o:O:m:N:H:S:s:w:t:U:P:A:d:p:f:F:-: hy" o; do
garciadeblas38d91ee2019-11-07 16:31:23 +0100120 case "${o}" in
Antonio Marsico75a38c72020-12-21 17:29:42 +0100121 D)
122 DEVOPS_PATH="${OPTARG}"
123 ;;
garciadeblas38d91ee2019-11-07 16:31:23 +0100124 r)
125 REPOSITORY="${OPTARG}"
126 ;;
127 R)
128 RELEASE="${OPTARG}"
129 ;;
130 u)
131 REPOSITORY_BASE="${OPTARG}"
132 ;;
133 t)
garciadeblas25e87d22020-01-31 14:27:29 +0100134 DOCKER_TAG="${OPTARG}"
garciadeblas38d91ee2019-11-07 16:31:23 +0100135 ;;
garciadeblas72399e32019-11-22 10:09:40 +0100136 -)
137 [ "${OPTARG}" == "help" ] && usage && exit 0
Dominik Fleischmann5e4a7512020-03-06 14:05:06 +0100138 ;;
garciadeblas25e87d22020-01-31 14:27:29 +0100139 :)
140 echo "Option -$OPTARG requires an argument" >&2
141 usage && exit 1
142 ;;
143 \?)
144 echo -e "Invalid option: '-$OPTARG'\n" >&2
145 usage && exit 1
146 ;;
147 h)
148 usage && exit 0
149 ;;
garciadeblas38d91ee2019-11-07 16:31:23 +0100150 *)
151 ;;
152 esac
153done
154
garciadeblas25e87d22020-01-31 14:27:29 +0100155clean_old_repo
garciadeblasd8bc5c32018-05-09 17:37:56 +0200156add_repo "deb [arch=amd64] $REPOSITORY_BASE/$RELEASE $REPOSITORY devops"
garciadeblas35f96ae2018-05-23 12:33:36 +0200157sudo DEBIAN_FRONTEND=noninteractive apt-get -q update
158sudo DEBIAN_FRONTEND=noninteractive apt-get install osm-devops
Antonio Marsico75a38c72020-12-21 17:29:42 +0100159$DEVOPS_PATH/installers/full_install_osm.sh -R $RELEASE -r $REPOSITORY -u $REPOSITORY_BASE -D $DEVOPS_PATH -t $DOCKER_TAG "$@"